package
{
	import flash.geom.Point;
	
	import org.flixel.FlxObject;

	public class Board
	{		
		public static var width:int=20;
		public static var height:int=20;
		
		public var board:Vector.<Vector.<int>>;
		public var pointstart:Vector.<Vector.<Point>>;
		public var pointend:Vector.<Vector.<Point>>;
		
		public static var leftmargin:int=20;//20;
		public static var toprow:int=10;
		public static var bottomrow:int=240;		
		public static var xgap:int=60;
		public static var ygap:int=60;
		
		public function copyboard():Vector.<Vector.<int>>
		{
			var b2 :Vector.<Vector.<int>> = new Vector.<Vector.<int>>();
			
			for (var i:int=0;i<width;i++)
			{
				var row:Vector.<int> = new Vector.<int>();
				for (var j:int=0;j<height;j++)
				{
					row.push(board[i][j]);
				}
				b2.push(row);
			}
			return b2;
		}
			
		public function blankboard():Vector.<Vector.<int>>
		{
			var b2 :Vector.<Vector.<int>> = new Vector.<Vector.<int>>();
			
			for (var i:int=0;i<width;i++)
			{
				var row:Vector.<int> = new Vector.<int>();
				for (var j:int=0;j<height;j++)
				{
					row.push(0);
				}
				b2.push(row);
			}
			return b2;
		}
		
		public function Board()
		{
			//0 means unoccupied, 1 means occupied, 2 means alive
			board = blankboard();
			pointstart = new Vector.<Vector.<Point>>();
			pointend = new Vector.<Vector.<Point>>();
			for (var i:int=0;i<width;i++)
			{
				var rowps:Vector.<Point> = new Vector.<Point>();
				var rowpe:Vector.<Point> = new Vector.<Point>();
				for (var j:int=0;j<height;j++)
				{
					rowps.push(new Point(leftmargin+xgap*(i),bottomrow));
					rowpe.push(new Point(leftmargin+ygap*(j),toprow));
				}
				pointstart.push(rowps);
				pointend.push(rowpe);
			}
			
			SpawnNew();
			
		}	
		
		private function GetVal(x:int,y:int):int
		{
			if (x<0||x>=width || y<0 || y>=height)
				return -1;
			else return board[x][y];
		}
		
		public function Tick(dir:uint):void
		{						
			if (TestMove(dir))
			{
				DoMove(dir);
			}
			else
			{
				if (dir==FlxObject.DOWN)
				{
					Staticify();	
					CheckLine();
					SpawnNew();	
				}
			}
		}
		
		private function CheckLine():void
		{
			
		}
		
		private function SpawnNew():void
		{		
			board[0][1]=2;
			board[1][1]=2;
			board[2][1]=2;
			board[1][0]=2;
		}
		
		private function Staticify():void
		{
			for (var i:int=0;i<width;i++)
			{
				for (var j:int=0;j<height;j++)
				{
					if (board[i][j]==2)
						board[i][j]=1;
				}
			}
		}
		
		private function DX(dir:uint):int
		{		
			var dx:int=0;
			switch (dir)
			{
				case FlxObject.UP:
					break;
				case FlxObject.DOWN:
					break;
				case FlxObject.LEFT:
					dx=-1;
					break;
				case FlxObject.RIGHT:
					dx=1;
					break;
			}
			return dx;			
		}
		private function DY(dir:uint):int
		{		
			var dy:int=0;
			switch (dir)
			{
				case FlxObject.UP:
					dy=-1;
					break;
				case FlxObject.DOWN:
					dy=1;
					break;
				case FlxObject.LEFT:
					break;
				case FlxObject.RIGHT:
					break;
			}
			return dy;			
		}
		
		private function TestMove(dir:uint):Boolean
		{
			var dx:int=DX(dir);
			var dy:int=DY(dir);
			
			var success:Boolean=true;
			for (var i:int=0;i<width && success;i++)
			{
				for (var j:int=0;j<height;j++)
				{
					if (board[i][j]==2)
					{
						var val:int = GetVal(i+dx,j+dy);
						if (val==1 || val ==-1)
						{
							success=false;
							break;
						}
					}
				}
			}
			
			return success;
		}
		private function DoMove(dir:uint):void
		{			
			var dx:int=DX(dir);
			var dy:int=DY(dir);
			
			
			var oldboard:Vector.<Vector.<int>>= copyboard();
			
			board = blankboard();
			
			for (var i:int=0;i<width;i++)
			{
				for (var j:int=0;j<height;j++)
				{
					switch (oldboard[i][j])
					{
						case 0:
							break;
						case 1:
							board[i][j]=1;
							break;
						default:
							board[i+dx][j+dy]=2;
							break;
					}
				}
			}				
			
		}
	}
}