package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.display.BlendMode;
	import flash.display.Shape;
	import flash.geom.Point;
	import flash.net.SharedObject;
	
	import flashx.textLayout.formats.Float;
	import flashx.textLayout.operations.CutOperation;
	
	import org.flixel.*;

	public class GameState extends FlxState
	{				
		
		[Embed(source="data/finish2.mp3")] public static var SndFinish2:Class;
		[Embed(source="data/hitwall.mp3")] public static var SndHitwall:Class;
		[Embed(source="data/rotate2.mp3")] public static var SndRotate2:Class;
		[Embed(source="data/specprov3.mp3")] public static var SndMusic:Class;
		[Embed(source="data/swap.mp3")] public static var SndSwap:Class;
		
		
		[Embed(source = 'data/level0.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel0:Class;
		
		[Embed(source = 'data/level1.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel1:Class;
		
		[Embed(source = 'data/level2.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel2:Class;
		
		[Embed(source = 'data/level3.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel3:Class;
		
		[Embed(source = 'data/level4.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel4:Class;
		
		[Embed(source = 'data/level5.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel5:Class;
		
		[Embed(source = 'data/level6.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel6:Class;
		
		[Embed(source = 'data/level7.txt', mimeType = "application/octet-stream")] 
		public var TxtLevel7:Class;
		
		private var time:Number;
		private var glowwidth:Number;
		private var board:Board;
		
		private var history:Vector.<Game>;
		private var game:Game;
		
		override public function create():void
		{
			super.create();
			history=new Vector.<Game>();

			var c:Class = this["TxtLevel"+FlxG.level];
			game = new Game(new c());
			
			//Board.width=game.map.length;
			//Board.height=game.map[0].length;
			Board.ygap = (FlxG.width-Board.leftmargin*2)/(game.map.length-1);
			Board.xgap = (FlxG.width-Board.leftmargin*2)/(game.map[0].length-1);
			board = new Board();
			
	time=0;
		}
		
		override public function update():void
		{
			if (fading)
			{
				super.update();
				return;
			}
			
			time+=FlxG.elapsed;
			glowwidth=(1+Math.sin(time*3))/2;
			
			if(FlxG.keys.justPressed("R"))
			{
				FlxG.switchState(new GameState());
			}
			
			if (FlxG.keys.justPressed("Z"))
			{
				if (history.length>0)
				{
					game=history.pop();
					game.ClearMoved();
					game.ProcessMoves();
				}
			}
			
			if (FlxG.keys.justPressed("UP"))
			{
				if (facing!=false)
				{
					FlxG.play(GameState.SndSwap,0.3);
					facing=false;
				}
			}
			if (FlxG.keys.justPressed("DOWN"))
			{
				if (facing!=true)
				{					
					FlxG.play(GameState.SndSwap,0.3);
					facing=true;
				}
			}
			var won:Boolean=false;
			var modified:Boolean=false;
			var gt:Game;
			var pressed:Boolean=false;
			if (FlxG.keys.justPressed("LEFT"))
			{
				pressed=true;
				if (facing)
				{
					gt = game.Copy();
					game.ClearMoved();		
					modified = game.TryMove(game.player,FlxObject.UP);
					won=game.ProcessMoves();					
				}
				else
				{
					gt = game.Copy();
					game.ClearMoved();		
					modified=game.TryMove(game.player,FlxObject.LEFT);
					won=game.ProcessMoves();					
				}
			}
			if (FlxG.keys.justPressed("RIGHT"))
			{
				pressed=true;
				if (facing)
				{
					gt = game.Copy();
					game.ClearMoved();		
					modified=game.TryMove(game.player,FlxObject.DOWN);
					won=game.ProcessMoves();
				}
				else
				{
					gt = game.Copy();
					game.ClearMoved();		
					modified=game.TryMove(game.player,FlxObject.RIGHT);
					won=game.ProcessMoves();					
				}
			}
			
			if (won)
			{
				
				FlxG.play(GameState.SndFinish2);
			}
			else if (modified)
			{
				FlxG.play(GameState.SndRotate2);
			}
			else if (pressed)
			{
				FlxG.play(GameState.SndHitwall,0.5);
			}
				
			if (won)
			{				
				fading=true;
			//	var s:FlxSound = FlxG.play(SndFinished);
			//	s.survive=true;
				FlxG.fade(0xff000000,0.5,FadeComplete,true);
			}	
			
			if (modified)
			{
				history.push(gt);
			}
			
			super.update();
		}
		private var fading:Boolean=false;
		
		private function FadeComplete():void
		{
			FlxG.level++;
			
			var save:FlxSave = new FlxSave();			
			if (save.bind("COCOTRISLEVEL"))
			{
				save.data.level=FlxG.level;					
			}
			
			
			if (FlxG.level<6)
			{
				FlxG.switchState(new InterimState());				
			}
			else
			{
				FlxG.switchState(new EndState());
			}
		}
		
		override public function draw():void
		{
			super.draw();						
			var lines:Shape = new Shape();
			lines.blendMode = BlendMode.ADD;
			
			//draw background
			for (var i:int=0;i<game.map.length;i++)
			{
				for (var j:int=0;j<game.map[i].length;j++)
				{
					var pa:Point = board.pointstart[j][i];
					var pb:Point = board.pointend[j][i];

					var val:int = game.map[i][j];// board.board[i][j];
					switch(val)
					{
						case 1://'#'
							lines.graphics.lineStyle(1,0xffffff,0.1);
							break;
						case 2://' '
							lines.graphics.lineStyle(1,0xffffff,0.4);
							break;
						case 3://'.'
							lines.graphics.lineStyle(4,0xff0000,1.0);
							break;
						default:
							trace(":("+val);
					}
					lines.graphics.moveTo(pa.x,pa.y);
					lines.graphics.lineTo(pb.x,pb.y);										
				}
			}
			
			for (i=0;i<game.blocks.length;i++)
			{
				var bd:BlockDat = game.blocks[i];
				
				if (bd.satisfied)
				{
					lines.graphics.lineStyle(3,0xddffff,1.0);				
				}
				else
				{
					lines.graphics.lineStyle(1,0x00ffff,1.0);					
				}
				
				pa = board.pointstart[bd.x][bd.y];
				pb = board.pointend[bd.x][bd.y];
				
				lines.graphics.moveTo(pa.x,pa.y);
				lines.graphics.lineTo(pb.x,pb.y);
			}
			
			lines.graphics.lineStyle(2,0x00ff00);
			
			pa = board.pointstart[game.player.x][game.player.y];
			pb = board.pointend[game.player.x][game.player.y];
			
			lines.graphics.moveTo(pa.x,pa.y);
			lines.graphics.lineTo(pb.x,pb.y);
			
			if (facing)
			{
				lines.graphics.drawCircle(pa.x,pa.y,playerradius);
			}
			else
			{
				lines.graphics.drawCircle(pb.x,pb.y,playerradius);				
			}
			
			FlxG.camera.buffer.draw(lines);			
		}
		
		private const playerradius:Number=3;
		private var facing:Boolean=false;
	}
	
}