package
{
	import com.greensock.TweenLite;
	import com.greensock.TweenMax;
	import com.greensock.plugins.HexColorsPlugin;
	import com.greensock.plugins.TweenPlugin;
	
	import flash.net.SharedObject;
	
	import flashx.textLayout.operations.CutOperation;
	
	import org.flixel.*;

	public class TitleState extends FlxState
	{				
		
		
		[Embed(source="data/title.png")] public static var ImgTitle:Class;
		
		override public function create():void
		{
			super.create();				
			FlxG.playMusic(GameState.SndMusic);
			FlxG.level=0;
			var save:FlxSave = new FlxSave();			
			if (save.bind("COCOTRISLEVEL"))
			{
				FlxG.level =  save.data.level;				
			}
			if (FlxG.level>=6)
				FlxG.level=0;
			
			var spr:FlxSprite = new FlxSprite(FlxG.width/2-20,60+20);
			spr.loadGraphic(ImgTitle,true,false,41,9);
			spr.addAnimation("default",[0,1],1,true);
			spr.play("default");
			spr.scale = new FlxPoint(700/81,700/81);
			add(spr);
			
			var txt:FlxText = new FlxText(0,FlxG.height/2,FlxG.width,"SO<O0^^");
			txt.color=0xffaaaaaa;
			txt.alignment="center";
			this.add(txt);			
			
			
			var txt2:FlxButton = new FlxButton(FlxG.width/2,FlxG.height*2/3,"New Game",ClickStart);
			txt2.color=0xff666666;
			txt2.x-=txt2.width/2;
			this.add(txt2);			
			
			var txt3:FlxButton = new FlxButton(FlxG.width/2,FlxG.height*2/3+40,"Continue",ClickContinue);
			txt3.color=0xff666666;
			txt3.x-=txt3.width/2;
			this.add(txt3);		
			if (FlxG.level==0)
			{
				txt3.update();
				txt3.active=false;
				txt3.alpha=0.3;
			}			
		}
		
		private var fading:Boolean=false;
		
		override public function update():void
		{
			super.update();
			if (fading)
				return;
		}		
		
		private function ClickStart():void
		{			
			if (fading)
				return;
			
			FlxG.play(GameState.SndRotate2);
			var save:FlxSave = new FlxSave();
			FlxG.level=0;
			if (save.bind("COCOTRISLEVEL"))
			{
				save.data.level=FlxG.level;
			}
			
			if(fading) return;
			fading=true;
			FlxG.fade(0xff000000,1,OnNewComplete,true);
			FlxG.music.fadeOut(1);
			
		}
		
		
		
		private function ClickContinue():void
		{			
			if (fading)
				return;
			FlxG.play(GameState.SndRotate2);
			var save:FlxSave = new FlxSave();			
			if (save.bind("COCOTRISLEVEL"))
			{
				save.data.level=FlxG.level;
			}
			
			if(fading) return;
			fading=true;
			FlxG.fade(0xff000000,1,OnComplete,true);
			FlxG.music.fadeOut(1);

		}
		
		private function OnComplete():void
		{			
			FlxG.switchState(new GameState());
		}
		
		private function OnNewComplete():void
		{
			FlxG.switchState(new PreludeState());
		}
		
	}
}